/**
 * @file
 * Provides mobile toggler for the the Ultimenu main block.
 */

(function ($, Drupal, window) {

  "use strict";

  Drupal.ultimenu = Drupal.ultimenu || {};
  var ultimenuTimer;

  Drupal.behaviors.ultimenu = {
    attach: function (context) {

      $(context).find("[data-ultimenu]").once("ultimenu").each(function () {
        var t = $(this),
          $link = t.find(".ultimenu__link");
        if (!$link.find(".caret").length) {
          $link.append("<span class='caret' />");
        }

        t.on("click", ".caret", function (e) {
          e.preventDefault();
          $(this).parent().toggleClass("js-ultimenu-active");
          $(this).parent().next(".ultimenu__flyout")
            .not(":animated").slideToggle();
        });
      });

      $("[data-ultimenu-button]").once("ultimenu-button").click(function (e) {
          e.preventDefault();
          $(this).toggleClass("js-ultimenu-button-active");
          $("body").toggleClass("js-ultimenu-expanded");
          $("[data-ultimenu] .ultimenu__link")
            .removeClass("js-ultimenu-active")
            .next(".ultimenu__flyout")
            .slideUp();
          $($(this).data("ultimenuButton")).not(":animated").slideToggle();
      });

      $(window).off("resize.ultimenu").on("resize.ultimenu", function () {
        window.clearTimeout(ultimenuTimer);
        ultimenuTimer = window.setTimeout(Drupal.ultimenu.ultimenuMain, 100);
      });
    }
  };

  Drupal.ultimenu.ultimenuMain = function () {
    if ($("[data-ultimenu-button]").is(":hidden")) {
      $("body").removeClass("js-ultimenu-expanded");
      $("[data-ultimenu]").show();
    }
  };

})(jQuery, Drupal, this);
